/***************************************************************************
 *   Copyright (C) 2006 by Thomas Jarosch                                  *
 *   info@intra2net.com                                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef __LOGREAD_HXX
#define __LOGREAD_HXX

#include <string>

/**
    Log file reader class.

    Works on complete and incomplete lines.
    Devire from this class and implement your
    own processLine() / processUnfinishedLine() function.
*/
class logread
{
public:
    logread(std::string filename, bool _goto_end=false);
    void read();

protected:
    std::string line;

    virtual void processUnfinishedLine() {};
    virtual void processLine() {};

private:
    // Internal implementation
    void reset();
    void goto_end();

    bool check_changed();
    bool process();

    std::string getLogChanges();
    void extractSingeLine (std::string &input);

    std::string filename;
    int logsize;
    int logsize_old;

    bool line_complete;
};

#endif
